import { JsonRpcProviderInterop } from './JsonRpcProviderInterop.js';
import { Eip1193Provider } from './Eip1193Provider.js';
import { LegacyProvider } from './LegacyProvider.js';
import { NullProvider } from './NullProvider.js';
const globalWindow = window;
const resolveObjFromPath = (object, path) => path.split('.').reduce((o, p) => o === null || o === void 0 ? void 0 : o[p], object);
export class EtherInterop {
    constructor() {
    }
    initProvider(name, options) {
        const provider = this.createProvider(options);
        return provider;
    }
    //--
    createProvider(options) {
        // resolve the external provider from the path 
        const externalProvider = resolveObjFromPath(globalWindow, options.providerPath);
        if (externalProvider !== undefined) {
            const provider = options.supportsEip1193 ?
                new Eip1193Provider(externalProvider, options) :
                new LegacyProvider(externalProvider, options);
            const providerInterop = new JsonRpcProviderInterop(provider);
            return providerInterop;
        }
        return new JsonRpcProviderInterop(new NullProvider(options));
    }
}
export const EtherInteropService = new EtherInterop();
//# sourceMappingURL=EtherInterop.js.map