import { promiseTimeout } from './utils.js';
//-- 
export class JsonRpcProvider {
    constructor(options) {
        this._options = options;
    }
    isAvailable() {
        return false;
    }
    request(request, timeoutInMs) {
        if (timeoutInMs != null) {
            return promiseTimeout(this.requestImp(request), timeoutInMs, new Error("Timeout"));
        }
        return this.requestImp(request);
    }
    configureEvents(dotNetReference) {
        // default is do nothing
    }
}
export class JsonRpcProviderRcpErrorException extends Error {
    constructor(rpcError) {
        super();
        this._rpcError = rpcError;
        Object.setPrototypeOf(this, JsonRpcProviderRcpErrorException.prototype);
    }
    get rpcError() {
        return this._rpcError;
    }
}
//# sourceMappingURL=JsonRpcProvider.js.map